/*
 * core_dbg.c
 *
 *  Created on: 2014-10-11
 *      Author: lenovo
 */
#include "uart.h"
#include "sys_dbg.h"
#include <stdio.h>
#include <string.h>

#define UART_DEBUG_ENABLE		1
#define CONSOLE_DEBUG_ENABLE	0
#define NETWORK_DEBGU_ENABLE	0

#if UART_DEBUG_ENABLE
static int uart_opened = 0;
#endif

void sys_dbg_real(const char *level, const char *fun_name, const char *format, ...)
{
	va_list argptr;
	char msg[1024];
	int dbg_prefix_len;

#if UART_DEBUG_ENABLE
	int i;
	static UART_Handle uart;
	static int uart_timeout = (0x00080000);
#endif

	memset(msg, 0x0, sizeof(msg));

	sprintf(msg, "%s | %s | ", level, fun_name);

	dbg_prefix_len = strlen(msg);

	va_start(argptr, format);

	vsnprintf(msg + dbg_prefix_len, sizeof(msg) - dbg_prefix_len, format, argptr);

#if CONSOLE_DEBUG_ENABLE
		System_printf("%s", msg);
#endif

#if UART_DEBUG_ENABLE
	/* Open Uart Handle */
	if (!uart_opened)
	{
		if ((uart = _UART_open(UART_0, /*115200*/26)) == 0)
		{
			printf("Open uart error\n");
			return;
		}

		uart_opened = 1;
	}

	for (i = 0; i < strlen(msg); i++)
	{
		if (msg[i] == '\n')
		{
			uart_send(uart, '\r', uart_timeout);
//			uart_send(uart, '\n', uart_timeout);
		}

		if (uart_send(uart, msg[i], uart_timeout))   // TX
			return;
	}


#endif

#if NETWORK_DEBGU_ENABLE
#endif

}
