/**********************************************************
 * sys_dbg.h
 *
 *  Copy right (c) 2014, hzhy Co., Ltd.
 *
 *  Created on: 2014-7-29
 *     	Author: David.shen
 *     Version: v0.0.1
 *
 *********************************************************/

#ifndef SYS_DBG_H_
#define SYS_DBG_H_

#include <stdlib.h>
#include <stdarg.h>

void sys_dbg_real(const char *level, const char *fun_name, const char *format, ...);
void dbg_flush_on_func();
void dbg_flush_off_func();

enum
{
	TRACE_ERR = 0,
	TRACE_WAR,
	TRACE_INFO,
	TRACE_VERB,

	NUM_TRACE_LEVEL
};

#if (DEBUG_LEVEL == 0)
#define sys_dbg_err(...)	sys_dbg_real("Error", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_warn(...)
#define sys_dbg_info(...)
#define sys_dbg_verb(...)
#elif (DEBUG_LEVEL == 1)
#define sys_dbg_err(...)	sys_dbg_real("Error", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_warn(...)	sys_dbg_real("Warning", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_info(...)
#define sys_dbg_verb(...)
#elif (DEBUG_LEVEL == 2)
#define sys_dbg_err(...)	sys_dbg_real("Error", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_warn(...)	sys_dbg_real("Warning", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_info(...)	sys_dbg_real("Info", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_verb(...)
#elif (DEBUG_LEVEL == 3)
#define sys_dbg_err(...)	sys_dbg_real("Error", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_warn(...)	sys_dbg_real("Warning", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_info(...)	sys_dbg_real("Info", __FUNCTION__, __VA_ARGS__)
#define sys_dbg_verb(...)	sys_dbg_real("Verbose", __FUNCTION__, __VA_ARGS__)
#else
#define sys_dbg_err		printf
#define sys_dbg_warn	printf
#define sys_dbg_info	printf
#define sys_dbg_verb	printf
#endif

#define sys_assert(b)	\
do {					\
	if (!(b))			\
	{					\
		sys_dbg_err("Assert Line: %d in %s : %s\n", __LINE__, __FILE__, #b);	\
		exit(1);		\
	}					\
}while(0)

#endif /* SYS_DBG_H_ */
